/*
 ============================================================================

  This program is free software, released under the GNU General Public License
  (GPL version 2 or later).

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
  for more details.

  http://www.fsf.org/licenses/gpl.html

 ============================================================================
*/

#include "BBTrayMenu.h"

char *plugin_info[] =
{
	"BBTrayMenu 0.0.3",
	"BBTrayMenu",
	"0.0.3",
	"ysuke",
	"2005-12-16",
	"http://zzbb.hp.infoseek.co.jp/",
	"zb2_460@yahoo.co.jp",
	"@BBTrayMenu.ShowMenu"
};

#define szVersion       plugin_info[0]
#define szAppName       plugin_info[1]
#define szInfoVersion	plugin_info[2]
#define szInfoAuthor	plugin_info[3]
#define szInfoRelDate	plugin_info[4]
#define szInfoLink	plugin_info[5]
#define szInfoEmail	plugin_info[6]
#define szBroamList	plugin_info[7]


//===========================================================================

int beginPlugin(HINSTANCE hPluginInstance)
{
	WNDCLASS wc;
	hwndBlackbox = GetBBWnd();
	hInstance = hPluginInstance;

	// Register the window class...
	ZeroMemory(&wc,sizeof(wc));
	wc.lpfnWndProc = WndProc;			// our window procedure
	wc.hInstance = hPluginInstance;		// hInstance of .dll
	wc.lpszClassName = szAppName;		// our window class name
	if (!RegisterClass(&wc)) 
	{
		MessageBox(hwndBlackbox, "Error registering window class", szAppName, MB_OK | MB_ICONERROR | MB_TOPMOST);
		return 1;
	}

	// Create the window...
	hwndPlugin = CreateWindowEx(
						WS_EX_TOOLWINDOW,								// window style
						szAppName,										// our window class name
						NULL,											// NULL -> does not show up in task manager!
						0,
						0, 0, 0, 0,											// window height
						NULL,											// parent window
						NULL,											// no menu
						hPluginInstance,								// hInstance of .dll
						NULL);
	if (!hwndPlugin)
	{						   
		MessageBox(0, "Error creating window", szAppName, MB_OK | MB_ICONERROR | MB_TOPMOST);
		// Unregister Blackbox messages...
		SendMessage(hwndBlackbox, BB_UNREGISTERMESSAGE, (WPARAM)hwndPlugin, (LPARAM)msgs);
		return 1;
	}
	// Register to receive Blackbox messages...
	SendMessage(hwndBlackbox, BB_REGISTERMESSAGE, (WPARAM)hwndPlugin, (LPARAM)msgs);

	return 0;
}

//===========================================================================

void endPlugin(HINSTANCE hPluginInstance)
{
        DestroyWindow(hwndPlugin);
        SendMessage(hwndBlackbox, BB_UNREGISTERMESSAGE, (WPARAM)hwndPlugin, (LPARAM)msgs);
        UnregisterClass(szAppName, hPluginInstance);
}

//===========================================================================

LPCSTR pluginInfo(int field)
{
	switch (field)
	{
		default:
		case 0: return szVersion;
		case 1: return szAppName;
		case 2: return szInfoVersion;
		case 3: return szInfoAuthor;
		case 4: return szInfoRelDate;
		case 5: return szInfoLink;
		case 6: return szInfoEmail;
		case 7: return szBroamList;
	}
}

//===========================================================================

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case BB_BROADCAST:
		{
			szTemp = (char*)lParam;

			if (strnicmp(szTemp, "@BBTrayMenu.", 12))
				return 0;
			szTemp += 12;

			if (!_strnicmp(szTemp, "LeftClick ", 9)){
				int num = atoi(szTemp + 10);
				if (num < GetTraySize()){

				systemTray* icon;
				icon = GetTrayIcon(num);

				if (!IsWindow(icon->hWnd)){
					PostMessage(hwndBlackbox, BB_CLEANTRAY, 0, 0);
				}else{
					SetForegroundWindow(icon->hWnd);
					PostMessage( icon->hWnd, icon->uCallbackMessage, icon->uID, WM_MOUSEMOVE );
					PostMessage( icon->hWnd, icon->uCallbackMessage, icon->uID, WM_LBUTTONDOWN );
					PostMessage( icon->hWnd, icon->uCallbackMessage, icon->uID, WM_LBUTTONUP );
				}

				}
				ShowMenu(MakeTrayMenu(false));
			}
			if (!_strnicmp(szTemp, "LeftDoubleClick ", 15)){
				int num = atoi(szTemp + 16);
				if (num < GetTraySize()){

				systemTray* icon;
				icon = GetTrayIcon(num);

				if (!IsWindow(icon->hWnd)){
					PostMessage(hwndBlackbox, BB_CLEANTRAY, 0, 0);
				}else{
					SetForegroundWindow(icon->hWnd);
					PostMessage( icon->hWnd, icon->uCallbackMessage, icon->uID, WM_MOUSEMOVE );
					PostMessage( icon->hWnd, icon->uCallbackMessage, icon->uID, WM_LBUTTONDBLCLK );
                                }

				}
				ShowMenu(MakeTrayMenu(false));
			}
			if (!_strnicmp(szTemp, "RightClick ", 10)){
				int num = atoi(szTemp + 11);
				if (num < GetTraySize()){

				systemTray* icon;
				icon = GetTrayIcon(num);

				if (!IsWindow(icon->hWnd)){
					PostMessage(hwndBlackbox, BB_CLEANTRAY, 0, 0);
				}else{
					SetForegroundWindow(icon->hWnd);
					PostMessage( icon->hWnd, icon->uCallbackMessage, icon->uID, WM_MOUSEMOVE );
					PostMessage( icon->hWnd, icon->uCallbackMessage, icon->uID, WM_RBUTTONDOWN );
					PostMessage( icon->hWnd, icon->uCallbackMessage, icon->uID, WM_RBUTTONUP );
                                }

				}
				ShowMenu(MakeTrayMenu(false));
			}

			if (!_stricmp(szTemp, "ShowMenu"))
			{
				ShowMenu(MakeTrayMenu(true));
                        }
		} break;

 		// ==========
		default:
			return DefWindowProc(hwnd,message,wParam,lParam);
	}
	return 0;
}

//===========================================================================

Menu* MakeTrayMenu(bool popup)
{
	Menu *main = MakeNamedMenu("BBTrayMenu", "BBTM_tray", popup);

	for (int i = 0; i < GetTraySize(); i++){
    		char buf[80];
    		systemTray* icon;
    		icon = GetTrayIcon(i);

    		subMenu = MakeMenu(icon->szTip);
    		sprintf(buf, "@BBTrayMenu.LeftClick %d", i);
    		MakeMenuItem(subMenu, "LeftClick", buf, false);
    		sprintf(buf, "@BBTrayMenu.LeftDoubleClick %d", i);
    		MakeMenuItem(subMenu, "LeftDoubleClick", buf, false);
    		sprintf(buf, "@BBTrayMenu.RightClick %d", i);
    		MakeMenuItem(subMenu, "RightClick", buf, false);
    		MakeSubmenu(main, subMenu,  icon->szTip);
	}
	return main;
}

//===========================================================================
